/*
 *  rommon Simple Monitor
 * 
 *  Copyright (C) 1999-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2016-2017 by TOPPERS PROJECT Educational Working Group.
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: diskutils.c 698 2017-02-02 18:54:16Z roi $
 */

/*
 *  FatFS disk utilities
 */

#include <stdio.h>
#include <string.h>
#include "sys_defs.h"
#include "mondefs.h"
#include "serial.h"
#include "ff.h"

#define htol(a)   ((((a) >> 24) & 0xff) | (((a) >> 8) & 0x0000ff00) | (((a) << 8) & 0x00ff0000) | (((a) << 24) & 0xff000000))

#define NOCOMPRESS

#define LOAD_ADDRESS    0
#define RUN_ADDRESS     1
#define DCOMP_SIZE      2
#define COMP_SIZE       3
#define PLOAD_ADDRESS   4
#define NUM_PARAM       5

#define READ_SIZE       (32*1024)

typedef struct IMAGE_HEAD {
	UINT    magic;
	UINT    headCRC;
	UINT    timestamp;
	UINT    imagesize;
	UINT    loadaddress;
	UINT    entrypoint;
	UINT    imageCRC;
	UCHAR   OS;
	UCHAR   Arch;
	UCHAR   Type;
	UCHAR   Compression;
	UCHAR   ImageName[32];
} IMAGE_HEAD_t;

static FIL     FileObj;
static DIR     dirobj;
static FILINFO finfo;

static int     executable_file(const char *path);
static unsigned int loadfs(char *path, unsigned int *prm, int mode);

/*
 *  ץΥե
 */
unsigned long load_file(int id, unsigned long addr, unsigned long dsize, char *path)
{
	unsigned int prm[NUM_PARAM];

	prm[LOAD_ADDRESS]  = addr;
	prm[RUN_ADDRESS]   = 0;
	prm[DCOMP_SIZE]    = dsize;
	prm[COMP_SIZE]     = 0;
	if(dsize == 0)
		prm[PLOAD_ADDRESS] = addr;
	else
		prm[PLOAD_ADDRESS] = CLOAD_ADDRESS;

	if(id >= 0)
		printf("File [%s]\n", path);
	if(*path != 0){
		prm[COMP_SIZE] = loadfs(path, prm, 0);
		if(prm[COMP_SIZE] == 0){
			if(id >= 0)
				printf("Load Error!!\n");
			return 0;
		}
		if(id >= 0){
			printf("\nLoad Address    = 0x%08x\n", prm[LOAD_ADDRESS]);
			printf("Execute Size    = 0x%08x\n", prm[DCOMP_SIZE]);
			printf("File Size       = 0x%08x\n", prm[COMP_SIZE]);
		}
		if(prm[RUN_ADDRESS] >= prm[LOAD_ADDRESS]){
#if !defined(RESET_VECTOR)
			UserVector[0] = prm[RUN_ADDRESS];
#else
			UserVector[RESET_VECTOR] = prm[RUN_ADDRESS];
#endif
			if(id >= 0)
				printf("Run Address     = 0x%08x\n", prm[RUN_ADDRESS]);
		}

#ifndef NOCOMPRESS
		if(prm[LOAD_ADDRESS] != prm[PLOAD_ADDRESS] && prm[COMP_SIZE] > 0){	/* COMPRESS CASE */
			def_sid = id;
			res = uncompress((char *)prm[LOAD_ADDRESS], &prm[DCOMP_SIZE], (const char *)prm[PLOAD_ADDRESS], prm[COMP_SIZE]);
			if(id >= 0)
				printf("Compress Result = %d\n", res);
		}
#endif	/* ROI DEBUG */
		return prm[RUN_ADDRESS];
	}
	else
		return 0;
}

/*
 *  ǥ쥯ȥɽ
 */
void disp_dir(int id, char *path)
{
	FRESULT res;
	int count = 0;
	int i;
	char name[16];

	res = f_opendir(&dirobj, path);
	if(res == FR_OK){
		printf("\nDirectory [%s]\n", path);
		while((res = f_readdir(&dirobj, &finfo)) == FR_OK && dirobj.sect != 0){
			count++;
			for(i = 0 ; i < (8+1+3) ; i++)
				name[i] = ' ';
			name[i] = 0;
			for(i = 0 ; i < (8+1+3) && finfo.fname[i] != 0 ; i++)
				name[i] = finfo.fname[i];
			printf("%4d %s ", count, name);
			if(finfo.fattrib & AM_HID)
				name[0] = '*';
			else
				name[0] = ' ';
			if(finfo.fattrib & AM_SYS)
				name[1] = 'S';
			else
				name[1] = ' ';
			name[2] = 'R';
			if(finfo.fattrib & AM_RDO)
				name[3] = ' ';
			else
				name[3] = 'W';
			name[4] = 0;
			if(finfo.fattrib & AM_DIR){
				printf("<DIR>  \n");
			}
			else if(finfo.fattrib & AM_VOL){
				printf("<VOL>  \n");
			}
			else{
				printf("[%s]  %8d\n", name, (int)finfo.fsize);
			}
		}
		printf("    %4d file(s)\n", count);
	}
}

/*
 *  ¹Էե
 */
static int executable_file(const char *path)
{
	while(*path != 0){
		if(strcmp(".img", path) == 0)
			return 1;
		path++;
	}
	return 0;
}

/*
 *  FATFSѻΥեɴؿ
 */
static unsigned int loadfs(char *path, unsigned int *prm, int mode)
{
	IMAGE_HEAD_t  head;
	FRESULT       res;
	int           fsize, count;
	UINT          n;
	unsigned int  addr;

	res = f_open(&FileObj, path, FA_READ);
	if(res != FR_OK)
		return 0;
	prm[COMP_SIZE] = FileObj.fsize;
	if(prm[DCOMP_SIZE] == 0)
		prm[DCOMP_SIZE] = FileObj.fsize;
	if(mode == 0 && executable_file(path)){
		res = f_read(&FileObj, (void *)&head, sizeof(IMAGE_HEAD_t), &n);
		if(res != FR_OK || sizeof(IMAGE_HEAD_t) != n){
			f_close(&FileObj);		/* CLOSE */
			return 0;
		}
		if(head.magic != 0x56190527){
			f_close(&FileObj);		/* CLOSE */
			return 0;
		}
#ifdef NOCOMPRESS
		if(head.Compression != 0x00){
			f_close(&FileObj);		/* CLOSE */
			return 0;
		}
#endif
		prm[LOAD_ADDRESS]  = htol(head.loadaddress);
		prm[RUN_ADDRESS]   = prm[LOAD_ADDRESS] + htol(head.entrypoint);
		prm[DCOMP_SIZE]    = htol(head.imagesize);
		prm[COMP_SIZE]     = FileObj.fsize - sizeof(IMAGE_HEAD_t);
		if(head.Compression == 0x00)
			prm[PLOAD_ADDRESS] = prm[LOAD_ADDRESS];
		else
			prm[PLOAD_ADDRESS] = CLOAD_ADDRESS;
	}
	addr  = prm[PLOAD_ADDRESS];
	fsize = prm[COMP_SIZE];
	while(fsize > 0){				/* READ */
		if(fsize > READ_SIZE)
			count = READ_SIZE;
		else
			count = fsize;
	    res =  f_read(&FileObj, (void *)addr, count, &n);
		if(res != FR_OK || count != n){
			f_close(&FileObj);		/* CLOSE */
			return 0;
		}
		addr  += count;
		fsize -= count;
	}
	f_close(&FileObj);				/* CLOSE */
	return prm[COMP_SIZE];
}

