/*
 *  rommon Simple Monitor
 * 
 *  Copyright (C) 1999-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2007 by GJ Business Division RICOH COMPANY,LTD. JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */

/*
 *	rommon Serial/Volume Functions
 */
#include "sys_defs.h"
#include "sil.h"
#include "serial.h"
#include "sdmmc.h"
#include "ff.h"
#include "diskio.h"

#ifndef TRUE
#define TRUE    1
#endif
#ifndef FALSE
#define FALSE   0
#endif

#include <stdio.h>

typedef void (*func)(uint32_t icciar, void * context);


#ifndef INT_PROVISION_CPU_COUNT
#define INT_PROVISION_CPU_COUNT   1
#endif


/*
 *  SILؿΥޥ
 */
#define sil_orw_mem(a, b)		sil_wrw_mem((a), sil_rew_mem(a) | (b))
#define sil_andw_mem(a, b)		sil_wrw_mem((a), sil_rew_mem(a) & ~(b))
#define sil_modw_mem(a, b, c)	sil_wrw_mem((a), (sil_rew_mem(a) & (~b)) | (c))

#define SDCARD_DEVNO   0
#define RETRY_COUNT    8

void *UserVector;

typedef struct sio_port_control_block {
	uint32_t      base;
	void *        func;
	uint32_t      intno;
	uint32_t      id;
	int           opened;
	unsigned int  errcount;
} sio_port_control_block_t;

static sio_port_control_block_t sio_pcb_table[MAX_SERIAL] = {
	{TADR_UART0_BASE, 0, INTNO_UART0, 0, 0, 0}
#if MAX_SERIAL >= 2
	,{TADR_UART1_BASE, 0, INTNO_UART1, 1, 0, 0}
#endif
};

/*
 *  Interrupt attribute(s) flags
 */
#define INT_FLAG_IMPLEMENTED    0x01


/* Interrupt dispatch information
 / See Cortex-A9 MPCore TRM, section 1.3.
 / SGI (16) + PPI (16) + SPI count (224) = total number of interrupts. */
typedef struct INT_DISPATCH_s
{
    func    callback;
    void *  context;
}
INT_DISPATCH_t;


static INT_DISPATCH_t int_dispatch[TMAX_INTNO];
static uint8_t int_flag[TMAX_INTNO];

/*
 *  Number of CPU(s) in system
 */
static uint32_t int_count_cpu;

/*
 *  Number of interrupts in system, rounded up to nearest 32
 */
static uint32_t int_count_int;

/*
 *  Volume Device Data
 */
static SDMMC_Handle_t   *phsd;
static SDMMC_CardInfo_t CardInfo;
static FATFS ActiveFatFsObj;
static DSTATUS disk0_status;

static __inline uint32_t get_current_cpu_num(void)
{
    uint32_t affinity;

    /* Use the MPIDR. This is only available at PL1 or higher.
     / See ARMv7, section B4.1.106. */

    __asm ("MRC p15, 0, %0, c0, c0, 5" : "=r" (affinity));

    return affinity & 0xFF;
}


static void sys_putc(int c)
{
	SendTXWait(DEF_MON_SERIAL);
	SendTX(DEF_MON_SERIAL, c);
	if(c == '\n'){
		SendTXWait(DEF_MON_SERIAL);
		SendTX(DEF_MON_SERIAL, '\r');
	}
}

void sys_printf(const char *s)
{
	int c;

	while((c = *s++) != 0){
		if(c == '\n')
			sys_putc('\r');
		sys_putc(c);
	}
}

#if 1	/* ROI DEBUG */
void put_hex(char a, int val)
{
	int i, j;
	sys_putc(a);
	sys_putc(' ');
	for(i = 28 ; i >= 0 ; i-= 4){
		j = (val >> i) & 0xf;;
		if(j > 9)
			j += ('A'-10);
		else
			j += '0';
		sys_putc(j);
	}
	sys_putc('\n');
}
#endif	/* ROI DEBUG */

/*
 *  ̤㳰äν
 */
void undef_exception(void)
{
    sys_printf("Unregistered Exception occurs. UNDEF !\n");
    while(1);
}

void swi_exception(void)
{
    sys_printf("Unregistered Exception occurs. SWI !\n");
    while(1);
}

void prefetch_exception(void)
{
    sys_printf("Unregistered Exception occurs. PREFETCH !\n");
    while(1);
}

void reserved_exception(void)
{
    sys_printf("Reserved Exception occurs. !\n");
    while(1);
}

void data_abort_exception(void)
{
    sys_printf("Unregistered Exception occurs. DATA ABORT !\n");
    while(1);
}


void irq_exception(void)
{
    sys_printf("Unregistered Exception occurs. IRQ !\n");
    while(1);
}

void fiq_exception(void)
{
    sys_printf("Unregistered Exception occurs. FIQ !\n");
    while(1);
}

static int int_dist_target_set(uint32_t int_id, uint32_t target)
{
    if ((uint32_t)int_id >= TMAX_INTNO)
        return FALSE;
    else if((int_flag[int_id] & INT_FLAG_IMPLEMENTED) == 0)
        return FALSE;
    else if (target >= (1 << int_count_cpu)){
        if (target == (1 << get_current_cpu_num()))
			return TRUE;
		else
			return FALSE;
	}
	else if (int_id < 32)
		return TRUE;
	else{
		sil_wrb_mem((uint8_t *)(TADR_DIC_BASE+TOFF_DIC_ITR+(int_id * sizeof(uint8_t))), target); /* icdiptr */
		return TRUE;
	}
}

void __attribute__ ((interrupt)) IRQ_Handler(void)
{
    uint32_t icciar = sil_rew_mem((uint32_t *)(TADR_DICCPU_BASE+TOFF_DICCPU_IAR));
    uint32_t ackintid = icciar & DICCPU_IAR_ACKINTID;

    if(ackintid < TMAX_INTNO){
		if(int_dispatch[ackintid].callback){
			int_dispatch[ackintid].callback(icciar, int_dispatch[ackintid].context);
		}
	}
	sil_wrw_mem((uint32_t *)(TADR_DICCPU_BASE+TOFF_DICCPU_EOI), icciar); /* icceoir */
}

/*
 *  Optional Initialize(Before)
 */
void BeforeInit(void)
{
	int i;
	uint32_t icdictr = sil_rew_mem((uint32_t *)(TADR_DIC_BASE+TOFF_DIC_ICT));

	UserVector = (void *)(RAM_BASE+0x00000000);

	/*
	 * Initialize the global interrupt items
	 */
	int_count_cpu = ((icdictr >> 5) & 0x7) + 1;
	int_count_int = ((icdictr & 0x1F) + 1) << 5;

	/* Initialize the callback and context array
	 / Initialize interrupt flags array */
    for(i = 0; i < TMAX_INTNO; ++i){
		int_dispatch[i].callback = 0;
		int_dispatch[i].context  = 0;

        int_flag[i] = 0;
	}

	/* Some preloaders enable interrupts but does not properly cleanup. This
	 / will prevent interrupts from occuring when excution is handed off from
	 / the preloader. */
	sil_andw_mem((uint32_t *)(TADR_DIC_BASE+TOFF_DIC_CR), DIC_CR_ENABLE);

	/* Discover all interrupts that are implemented in hardware. */
    for(i = 0; i < (TMAX_INTNO / 32); ++i){
		int j;
		uint32_t value;
		/* Set the whole bank to be enabled. */
		sil_wrw_mem((uint32_t *)(TADR_DIC_BASE+TOFF_DIC_SE+(i * sizeof(uint32_t))), 0xffffffff); /* icdisern */

        /* Read it back to see which bits stick. */
        value = sil_rew_mem((uint32_t *)(TADR_DIC_BASE+TOFF_DIC_SE+(i * sizeof(uint32_t)))); /* icdisern */
        for (j = 0; j < 32; ++j){
			if(((1 << j) & value) != 0){
				int_flag[i * 32 + j] |= INT_FLAG_IMPLEMENTED;
			}
		}

		/* Clear the whole bank to be disabled. */
        sil_wrw_mem((uint32_t *)(TADR_DIC_BASE+ TOFF_DIC_CE+(i * sizeof(uint32_t))), 0xffffffff); /* icdicern */
    }

	/*
	 * Initialize the CPU interrupt items
	 */
	if (get_current_cpu_num() >= INT_PROVISION_CPU_COUNT){
        return;
	}

	/* Setup the priority mask and binary point defaults.
     / This will allow all interrupts to have sufficient priority to be
     / forwarded to the CPUs. */
	sil_wrw_mem((uint32_t *)(TADR_DICCPU_BASE+TOFF_DICCPU_PMR), 0xff); /* iccpmr */
	sil_wrw_mem((uint32_t *)(TADR_DICCPU_BASE+TOFF_DICCPU_BPR), 0); /* iccbpr */

#if BOARDNO != 1
	/* L4-0 WATCH DOG TIMER STOP */
	{
		uint32_t config = sil_rew_mem((uint32_t *)(TADR_L4WD0_BASE+TOFF_L4WD_CR));
		uint32_t tmp;
		sil_orw_mem((uint32_t *)(TADR_RSTMGR_BASE+TOFF_RSTMGR_PERMODRST), RSTMGR_PERMODRST_L4WD0);
		for(i = 0 ; i < 8 ; i++){
			tmp = sil_rew_mem((uint32_t *)(TADR_RSTMGR_BASE+TOFF_RSTMGR_PERMODRST));
		}
		(void)(tmp);
		sil_andw_mem((uint32_t *)(TADR_RSTMGR_BASE+TOFF_RSTMGR_PERMODRST), TOFF_RSTMGR_PERMODRST);
		config &= ~L4WD_CR_WDT_EN;
		sil_wrw_mem((uint32_t *)(TADR_L4WD0_BASE+TOFF_L4WD_CR), config);
	}
#endif
}

/*
 *  Optional Initialize(After)
 */
void AfterInit(void)
{
	/*
	 *  CPU Interrupt enable
	 */
	sil_orw_mem((uint32_t *)(TADR_DICCPU_BASE+TOFF_DICCPU_CR), DICCPU_CR_EN);	/* iccicr */
	/*
	 *  GLOBAL Interrupt enable
	 */
	sil_orw_mem((uint32_t *)(TADR_DIC_BASE+TOFF_DIC_CR), DIC_CR_ENABLE);

#ifdef USE_VOLUME
	sdmmc_init(0);
	sil_dly_nse(1000*1000);
	disk0_status = STA_NOINIT;

	int_dispatch[INTNO_SDMMC_IRQ].callback = sdmmc_hps_handler;
	int_dispatch[INTNO_SDMMC_IRQ].context  = 0;
	int_dist_target_set(INTNO_SDMMC_IRQ, 0x3);
#endif
	/*
	 *  interrupt(psio->intno) enable
	 */
	sil_wrw_mem((uint32_t *)(TADR_DIC_BASE+TOFF_DIC_SE+((INTNO_SDMMC_IRQ >> 5) * sizeof(uint32_t))), 1 << (INTNO_SDMMC_IRQ & 0x1F)); /* icdisern */
}

/*
 *  Optional Initialize(Volume Device)
 */
int VolumeInit(void)
{
#ifdef USE_VOLUME
	ER      ercd;
	FRESULT result;

	if(sdmmc_sense(0)){
		sil_dly_nse(20*1000*1000);
		phsd = sdmmc_open(0);
		if(phsd == NULL){
			sys_printf("SDMMC:open error !\n");
			return -1;
		}
		ercd = sdmmc_checkCID(phsd);
		if(ercd != E_OK){
			sys_printf("SDMMC:sdmmc_checkCID error !\n");
			return -1;
		}
		ercd = sdmmc_setaddress(phsd);
		if(ercd != E_OK){
			sys_printf("SDMMC:sdmmc_setaddress error !\n");
			return -1;
		}
		ercd = sdmmc_sendCSD(phsd);
		if(ercd != E_OK){
			sys_printf("SDMMC:sdmmc_sendCSD error !\n");
			return -1;
		}
		CardInfo.maxsector = 0;
		ercd = sdmmc_getcardinfo(phsd, &CardInfo);
		if(ercd != E_OK){
			sys_printf("SDMMC:sdmmc_getcardinfo error !\n");
			return -1;
		}
		ercd = sdmmc_select_card(phsd, (((uint32_t)CardInfo.RCA) << 16));
		if(ercd != E_OK){
			sys_printf("SDMMC:sdmmc_getcardinfo error !\n");
			return -1;
		}
		ercd = sdmmc_configuration(phsd);
		if(ercd != E_OK){
			sys_printf("SDMMC:sdmmc_configuration error !\n");
			return -1;
		}
		ercd = sdmmc_set_widebus(phsd);
		if(ercd != E_OK){
			sys_printf("SDMMC:sdmmc_set_widebus error !\n");
			return -1;
		}
		result = f_mount(SDCARD_DEVNO, &ActiveFatFsObj);
		if(result != FR_OK){
			sys_printf("SDMMC:f_mount error !\n");
			return -1;
		}
		disk0_status = 0;
		return 1;
	}
#endif
	return 0;
}

/*
 *  Uart Interrupt handler
 */
void uart_int_handler(uint32_t icciar, void * context)
{
	sio_port_control_block_t *psio = (sio_port_control_block_t *)context;
	uint32_t status;

	status = sil_rew_mem((uint32_t *)(psio->base+TOFF_UART_IIR));
	if((status & UART_IIR_ID_E_RXDATAVAILABLE) != 0)
		ComInterRX(psio->id);
	if((status & UART_IIR_ID_E_THREMPTY) != 0)
		ComInterTX(psio->id);

}

/*
 *	Initialize Serial Channel
 *  Input: id: Serial Channel #
 */
void InitSIO(int id)
{
	sio_port_control_block_t *psio = &sio_pcb_table[id];
	uint32_t base;
	uint32_t lcr = 0;
	uint32_t fcr = 0;
	uint32_t divisor;
	uint32_t ucr;

	base = psio->base;

	/* The ALT_CLK_L4_SP is required for all SoCFPGA UARTs. Check that it's enabled. */
	if((sil_rew_mem((uint32_t *)(TADR_CLKMGR_MPLL_BASE+TOFF_CLKMGR_MPLL_EN)) & CLKMGR_MPLL_EN_L4SPCLK) == 0){
		return;
	}

	if (base == TADR_UART0_BASE){
		/* Bring UART0 out of reset. */
		sil_andw_mem((uint32_t *)(TADR_RSTMGR_BASE+TOFF_RSTMGR_PERMODRST), RSTMGR_PERMODRST_UART0);
	}
	else{ /* device == ALT_16550_DEVICE_SOCFPGA_UART1 */
		/* Bring UART1 out of reset. */
		sil_andw_mem((uint32_t *)(TADR_RSTMGR_BASE+TOFF_RSTMGR_PERMODRST), RSTMGR_PERMODRST_UART1);
	}

	/* Verify the UCR (UART Component Version) */
	ucr = sil_rew_mem((uint32_t *)(base+TOFF_UART_UCV));
	if (ucr != UART_UCV_UART_COMPONENT_VER){
		return;
	}

	/* Write SRR::UR (Shadow Reset Register :: UART Reset) */
	sil_wrw_mem((uint32_t *)(base+TOFF_UART_SRR), UART_SRR_UR);

	/* Read the MSR to work around case:119085. */
	divisor = sil_rew_mem((uint32_t *)(base+TOFF_UART_MSR));

	/* Set bit IER::PTIME (Interrupt Enable Register :: Programmable THRE Mode Enable) */
	sil_orw_mem((uint32_t *)(base+TOFF_UART_IER_DLH), UART_IER_DLH_PTIM);

	/* Configure the number of databits */
	lcr |= UART_LCR_DLS_E_LEN8;

	/* Configure the number of stopbits(1) */
	lcr |= 0<<2;

	/* Update LCR (Line Control Register) */
	sil_modw_mem((uint32_t *)(base+TOFF_UART_LCR), UART_LCR_DLS_MSK | UART_LCR_STOP | UART_LCR_PEN | UART_LCR_EPS_MSK, lcr);

	/*
	 *  enable FIFO
	 */
	fcr |= UART_FCR_FIFOE | UART_FCR_RFIFOR | UART_FCR_XFIFOR;
	sil_wrw_mem((uint32_t *)(base+TOFF_UART_FCR), fcr);

	/*
	 *  enable uart
	 */
	/* Enable Terminal*/
	sil_orw_mem((uint32_t *)(base+TOFF_UART_MCR), UART_MCR_DTR | UART_MCR_RTS);

    /* Write the divisor cached in the handle data to the divisor registers. */
    /* This will effectively enable the UART. */
	/* Add half of the denominator to address rounding errors. */
	/* Formula for calculating the divisor:
	//    baudrate = clock / (16 * divisor)
	// => baudrate * 16 * divisor = clock
	// => divisor = clock / (baudrate * 16)
	// => divisor = (clock / 16) / baudrate */
	divisor = ((UART_CLOCK + (8 * DEFAULT_SPEED)) / (16 * DEFAULT_SPEED));

	/* Set LCR::DLAB (Line Control Register :: Divisor Latch Access Bit) */
	sil_orw_mem((uint32_t *)(base+TOFF_UART_LCR), UART_LCR_DLAB);

	/* Write DLL (Divisor Latch Low). */
	sil_wrw_mem((uint32_t *)(base+TOFF_UART_RBR_THR_DLL), divisor & 0xff);

	/* Write DLH (Divisor Latch High). */
	sil_wrw_mem((uint32_t *)(base+TOFF_UART_IER_DLH), (divisor >> 8) & 0xff);

	/* Clear LCR::DLAB (Line Control Register :: Divisor Latch Access Bit) */
	sil_andw_mem((uint32_t *)(base+TOFF_UART_LCR), UART_LCR_DLAB);

	/* Update the enabled state in the handle data. */
	if (divisor != 0){
		psio->opened = 1;
	}

	/*
	 *  setup uart interrupt
	 */
	if ((int_flag[psio->intno] & INT_FLAG_IMPLEMENTED) != 0){
    	uint32_t regoffset   = psio->intno >> 5;
		uint32_t regbitshift = psio->intno & 0x1F;

		int_dispatch[psio->intno].callback = uart_int_handler;
		int_dispatch[psio->intno].context  = psio;
		if(psio->intno >= 32){
			int target = 0x3;
			int_dist_target_set(psio->intno, target);
		}
		/*
		 *  interrupt(psio->intno) enable
		 */
		sil_wrw_mem((uint32_t *)(TADR_DIC_BASE+TOFF_DIC_SE+(regoffset * sizeof(uint32_t))), 1 << regbitshift); /* icdisern */

		/*
		 *  enable Rx interrupt
		 */
		sil_orw_mem((uint32_t *)(base+TOFF_UART_IER_DLH), UART_IER_DLH_ERBFI);
	}
}

/*
 *  Get RX Data
 *  Input: id: Serial Channel #
 *  output: c: Rx Data
 */
unsigned short GetRxData(int id)
{
	uint32_t base = sio_pcb_table[id].base;
	return (sil_rew_mem((uint32_t *)(base+TOFF_UART_RBR_THR_DLL)) & 0xff) | CHKRXDATA;
}

/*
 *  Enable Tx interrupt
 *  Input: id: Serial Channel #
 */
void EnableITX(int id)
{
	uint32_t base = sio_pcb_table[id].base;
	sil_orw_mem((uint32_t *)(base+TOFF_UART_IER_DLH), UART_IER_DLH_ETBEI);
}

/*
 *  Disable Tx interrupt
 *  Input: id: Serial Channel #
 */
void DisableITX(int id)
{
	uint32_t base = sio_pcb_table[id].base;
	sil_andw_mem((uint32_t *)(base+TOFF_UART_IER_DLH), UART_IER_DLH_ETBEI);
}

/*
 *  Send Tx in interrupt
 *  Input: id: Serial Channel #
 *         c : Send charactor
 */
void SendTX(int id, char c)
{
	uint32_t base = sio_pcb_table[id].base;
	sil_wrw_mem((uint32_t *)(base+TOFF_UART_RBR_THR_DLL), c);
}

/*
 * Send Tx wait
 * Inputs: id: Serial Channel #
 */
void SendTXWait(int id)
{
	uint32_t base = sio_pcb_table[id].base;
	while((sil_rew_mem((uint32_t *)(base+TOFF_UART_LSR)) & UART_LSR_THRE) != 0);
}

#ifdef USE_VOLUME
/*
 *  FatFs Initial a Drive
 */
DSTATUS disk_initialize(BYTE pdrv)
{
	if(pdrv == SDCARD_DEVNO)
		return disk0_status;
	else
		return STA_NOINIT;
}

/*
 *  FatFs Drive Status
 */
DSTATUS disk_status(BYTE pdrv)
{
	if(pdrv == SDCARD_DEVNO)
		return disk0_status;
	else
		return STA_NOINIT;
}

/*
 *  FatFs Read Sector(s)
 */
DRESULT disk_read(BYTE pdrv, BYTE *buff, DWORD sector, BYTE count)
{
	ER  ercd;
	int retry = 0;

	if(pdrv != SDCARD_DEVNO || buff == NULL || count == 0)
		return RES_ERROR;
	do{
		ercd = sdmmc_blockread(phsd, buff, sector * CardInfo.blocksize, CardInfo.blocksize, count);
		if(ercd == E_OK)
			ercd = sdmmc_wait_transfar(phsd, 30*1000);
		retry++;
	}while(ercd != E_OK && retry < RETRY_COUNT);
	if(ercd == E_OK)
		return RES_OK;
	else
		return RES_ERROR;
}
#endif

