/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2017 by TOPPERS PROJECT Educational Working Group.
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: sdcard.h,v 1.0 2016/11/02 18:11:54 roi Exp $
 */
/*
 *  STM32F746 SDMMCɥ饤Х󥯥롼ɥե
 */

#ifndef _SDMMC_H_
#define _SDMMC_H_

#ifdef __cplusplus
 extern "C" {
#endif

#define SD_CARD_V11         0
#define SD_CARD_V20         1
#define SD_CARD_HC          2
#define MMC_CARD			3
#define SD_IO_CARD          4
#define HS_MM_CARD          5
#define SD_IO_COMBO_CARD    6
#define MMC_CARD_HC         7

#define SD_CARD_NOTDETECT   32

/*
 *  Х
 */
#define SDMMC_BUS_WIDE_1B   1
#define SDMMC_BUS_WIDE_4B   4
#define SDMMC_BUS_WIDE_8B   8

#define SDMODE_PROTECT      (1<<5)

#define CMD_INDEX           0x003F

/*
 *  SD/MMC ޥɥꥹ
 */
#define MCI_CMD0			(0x00|0x2000a000)						/* GO_IDLE_STATE(MMC) or RESET(SD) */
#define MCI_CMD2			(0x02|0x200020c0)						/* ALL SEND_CID */
#define MCI_CMD3			(0x03|0x20002040)						/* SET_RELATE_ADDR */
#define MCI_CMD6			(0x06|0x20002240)						/* SEND SWITCH STATUS */
#define MCI_CMD7			(0x07|0x20002040)						/* SELECT/DESELECT_CARD */
#define MCI_CMD8            (0x08|0x20002040)						/* HS_SEND_EXT_CSD */
#define MCI_CMD9			(0x09|0x200020c0)						/* SEND_CSD */
#define MCI_CMD10			(0x0A|0x200020c0)						/* SEND_CID */
#define MCI_CMD12			(0x0C|0x20006000)						/* Stop either READ or WRITE operation */
#define MCI_CMD13			(0x0D|0x20000040)						/* SEND_STATUS */
#define MCI_CMD16			(0x10|0x20002040)						/* SET_BLOCK_LEN */
#define MCI_CMD17			(0x11|0x20002240)						/* READ_SINGLE_BLOCK */
#define MCI_CMD18			(0x12|0x20003240)						/* READ_MULTI_BLOCK */
#define MCI_CMD24			(0x18|0x20002240|SDMMC_CMD_RD_WR)		/* WRITE_SINGLE_BLOCK */
#define MCI_CMD25			(0x19|0x20003240|SDMMC_CMD_RD_WR)		/* WRITE_MULTI_BLOCK */
#define MCI_CMD55			(0x37|0x20002040)						/* APP_CMD, the following will a ACMD */

#define MCI_ACMD6			(0x06|0x20002040)						/* ACMD6 for SD card BUSWIDTH */
#define MCI_ACMD13			(0x0D|0x20000240)						/* ACMD13 for SD card status */
#define MCI_ACMD41			(0x29|0x20002040)						/* ACMD41 for SD card */
#define MCI_ACMD51			(0x33|0x20000240)						/* ACMD51 for SD SCR */

#define MCI_CLK             0x0020203f								/* CLOCK COMAND */

#define RES_CMD1            (MCI_CMD1 & CMD_INDEX)
#define RES_CMD12           (MCI_CMD12 & CMD_INDEX)
#define RES_ACMD41          (MCI_ACMD41 & CMD_INDEX)

/*
 *  SDMMACơ
 */
#define SDMMC_STATUS_NONE       0
#define SDMMC_STATUS_INIT       1
#define SDMMC_STATUS_READY      2
#define SDMMC_STATUS_ACTIVATE   3
/*
 *  SDMMC顼
 */
#define SDMMC_ERROR_NONE        0x00000000			/* No error */
#define SDMMC_ERROR_RESPONE     SDMMC_INTSTS_RE		/* Response error */
#define SDMMC_ERROR_RCRC        SDMMC_INTSTS_RCRC	/* Response CRC error */
#define SDMMC_ERROR_DCRC        SDMMC_INTSTS_DCRC	/* Data CRC error */
#define SDMMC_ERROR_RTO         SDMMC_INTSTS_BAR	/* Response Timeout error */
#define SDMMC_ERROR_DRTO        SDMMC_INTSTS_BDS	/* Data Read Timeout error */
#define SDMMC_ERROR_FRUN        SDMMC_INTSTS_FRUN	/* Fifo underun error */
#define SDMMC_ERROR_HLE         SDMMC_INTSTS_HLE	/* Hardware Locked Write Error */
#define SDMMC_ERROR_SBE         SDMMC_INTSTS_SBE	/* Start-bit error */
#define SDMMC_ERROR_EBE         SDMMC_INTSTS_EBE	/* End-bit Error */

#define SDMMC_ERROR_MASK        ( SDMMC_ERROR_RESPONE | SDMMC_ERROR_RCRC | SDMMC_ERROR_DCRC |\
                                  SDMMC_ERROR_RTO     | SDMMC_ERROR_DRTO | SDMMC_ERROR_FRUN |\
                                  SDMMC_ERROR_HLE     | SDMMC_ERROR_SBE  | SDMMC_ERROR_EBE )

#define INHNO_SDMMC  (0x00010000 | INTNO_SDMMC_IRQ)	/* ߥϥɥֹ */
#define INTNO_SDMMC  INTNO_SDMMC_IRQ	/* ֹ */
#define INTPRI_SDMMC -9			/* ͥ */
#define INTATR_SDMMC 0			/* ° */

#ifndef TOPPERS_MACRO_ONLY

/*
 *  SDMMCϥɥ鹽¤
 */

typedef struct
{
	uint32_t                base;		/* SDMMC쥸١ɥ쥹 */
	uint32_t                ClockMode;	/* ꥯå⡼ */
	uint32_t                BusWide;	/* Х */
	uint32_t                RetryCount;	/* ȥ饤 */
	uint32_t                cardtype;	/* ɥ */
	uint32_t                RCA;		/* RCA */
	uint32_t                CSD[4];		/* CSD */
	uint32_t                CID[4];		/* CID */
	uint32_t                SCR[2];		/* SCR */
    uint32_t                CCC;		/* CCC */
	uint32_t                block_size;	/* READ/WRITE֥å */
	bool_t                  high_speed;	/* 50MHz high speed */
	bool_t                  dma_enable;	/* DMA̵ͭ */
	uint8_t                 *pBuffPtr;	/* SDMMC ̿ХåեؤΥݥ */
	volatile uint32_t       XferCount;	/* SDMMC ̿ */
	volatile uint32_t       istatus;	/* ߾ */
	volatile uint32_t       dstatus;	/* DMA */
	volatile uint32_t       status;		/* ž */
	volatile uint32_t       SdCmd;		/* žꥳޥ */
	volatile uint32_t       ErrorCode;	/* 顼 */
}SDMMC_Handle_t;

/*
 *  SDMMCɾ¤
 */
typedef struct
{
	uint64_t                capacity;	/* (Х) */
	uint32_t                blocksize;	/* ֥å */
	uint32_t                maxsector;	/* 祻 */
	uint16_t                RCA;		/* SD RCA */
	uint8_t                 cardtype;	/* ɼ */
	uint8_t                 status;		/* ơ */

}SDMMC_CardInfo_t;



extern bool_t sdmmc_sense(int id);
extern void sdmmc_init(intptr_t exinf);
extern void sdmmc_deinit(int id);
extern bool_t sdmmc_card_is_write_protected(SDMMC_Handle_t *hsd);
extern SDMMC_Handle_t *sdmmc_open(int id);
extern ER sdmmc_close(SDMMC_Handle_t *hsd);
extern void sdmmc_hps_handler(uint32_t icciar, void * context);

extern ER sdmmc_checkCID(SDMMC_Handle_t *hsd);
extern ER sdmmc_setaddress(SDMMC_Handle_t *hsd);
extern ER sdmmc_setaddress(SDMMC_Handle_t *hsd);
extern ER sdmmc_sendCSD(SDMMC_Handle_t *hsd);
extern ER sdmmc_getcardinfo(SDMMC_Handle_t *hsd, SDMMC_CardInfo_t *pCardInfo);
extern ER sdmmc_select_card(SDMMC_Handle_t *hsd, uint64_t addr);
extern ER sdmmc_configuration(SDMMC_Handle_t *hsd);
extern ER sdmmc_set_widebus(SDMMC_Handle_t *hsd);
extern ER sdmmc_blockread(SDMMC_Handle_t *hsd, void *dest, uint64_t src, uint32_t blocksize, uint32_t num);
extern ER sdmmc_blockwrite(SDMMC_Handle_t *hsd, void *src, uint64_t WriteAddr, uint32_t blocksize, uint32_t num);
extern ER sdmmc_wait_transfar(SDMMC_Handle_t *hsd, uint32_t Timeout);

#endif /* TOPPERS_MACRO_ONLY */

#ifdef __cplusplus
}
#endif


#endif /* _SDMMC_H_ */

