/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2016      by 3rd Designing Center
 *              Imageing System Development Division RICOH COMPANY, LTD.
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: startup.S,v 1.00 2016/10/04 17:46:38 roi Exp $
 */

/*
 *    ͥѤΥȥåץ⥸塼(Cortex-A9)
 */
#define _MACRO_ONLY
#include "sys_defs.h"
#include "mondefs.h"
#include "serial.h"


        /*
         * Vectorơ֥ȥץơ֥
         * Ϲ0x3c
         */
        .section .vector,"a"
        .code 32
        .align 0
        .global vector_table
vector_table:
        ldr pc, reset_vector       /* ꥻå             */
        ldr pc, undef_vector       /* ̤̿           */
        ldr pc, swi_vector         /* եȥ   */
        ldr pc, prefech_vector     /* ץեåܡ */
        ldr pc, data_abort_vector  /* ǡܡ       */
        ldr pc, reserved_vector
        ldr pc, irq_vector         /* IRQ                  */
        ldr pc, fiq_vector         /* FRQ                  */

/*
 *  ٥ơ֥
 */
_kernel_arm_vector_add:
reset_vector:
        .long   start
undef_vector:
        .long   undef_exception
swi_vector:
        .long   swi_exception
prefech_vector:
        .long   prefetch_exception
data_abort_vector:
        .long   data_abort_exception
reserved_vector:
		.long   reserved_exception
irq_vector:
        .long   IRQ_Handler
fiq_vector:
        .long   fiq_exception

        .text
        .code 32
        .align     0
        .global    start
start:
        mrs	r0, cpsr		/* Interrupt disable */
        orr	r0, r0, #0xC0	/* Interrupt disable */
        msr	cpsr_cxsf,r0	/* Interrupt disable */

        mrc	p15,0,r0,c1,c0,2    /* read CPACR */
        orr	r0,r0,#0x00f00000   /* Enable NEON/VFP user access */
        mcr	p15,0,r0,c1,c0,2    /* Write to CPACR */
        isb
        mov	r0,#0x40000000      /* Enable VFP/NEON Hardware */
        mcr	p10, 7, r0, cr8, cr0, 0 /* Write to fpexc */

        /*
         * IRQå
         */
        mrs r3, CPSR
        msr CPSR_c, #(0x12 | 0x80 | 0x40) /* IRQ mode, IRQ, FIQ off */
        ldr r0,=__irq_stack__
        mov sp, r0
        msr CPSR_c, r3

        /*
         * åݥ󥿤ȡե졼ݥ󥿤ν
         * SL(å¥쥸r10)ꤹɬפ뤫?
         * gccϥǥեȤǤ-mapcsʤΤɬפʤ
         */
        ldr  r3,=__system_stack__
        mov  sp,r3
        mov  r11,#0        /* Arm⡼ѥե졼ݥ   */         
        mov  r7,#0         /* Thubm⡼ѥե졼ݥ */

        /*
         *  bssΥꥢ
         */
start_1:
        ldr     r1,=__bss_start
        ldr     r2,=__bss_end
        cmp     r1,r2
        bhs     start_3
        mov     r0,#0
start_2:
        str     r0,[r1],#4
        cmp     r1,r2
        blo     start_2

start_3:
#if ROM_EXEC != 0
        /*
         *  dataν(ROMб)
         *  __idata_start  __idata_end ޤǤ__data_start ʹߤ
         *  ԡ
         */
        ldr     r1,=__idata_start
        ldr     r3,=__idata_end
        cmp     r1,r3
        bhs     start_5
        ldr     r2,=__data_start
start_4:        
        ldr     r0,[r1],#4
        str     r0,[r2],#4
        cmp     r1,r3
        blo     start_4
#endif /* ROM EXEC MODE */
start_5:
        ldr     r0,=MonMain
        mov     lr,pc
        bx      r0

start_6:
		b       start_6

        .text
        .align 4
        .global Disable
        .global Enable
        .global SetVector

/*
 *  interrupt disable
 */
Disable:
        mrs  r0,CPSR
        orr  r0,r0,#0x80	@ I bit set
        msr  CPSR,r0
        bx   lr

/*
 *  interrupt enable
 */
Enable:
        mrs  r0,CPSR
        and  r0,r0,#~0x80	@ I bit reset
        msr  CPSR,r0
        bx   lr

/*
 *  set vector
 */
SetVector:
        mrc  p15, 0, r3, c1, c0, 0
        bic  r3, r3, #8192	/* 0x2000 */
        mcr  p15, 0, r3, c1, c0, 0
        mcr  p15, 0, r0, c12, c0, 0
        bx   lr

/*
 * եȥǥ쥣ؿ
 */
	    .global sil_dly_nse
sil_dly_nse:
        sub   r0, r0, #SIL_DLY_TIM1
        cmp   r0, #0
        bgt   _sil_dly_nse1
        bx    lr
_sil_dly_nse1:
        sub   r0, r0, #SIL_DLY_TIM2
        mov   r1, #1
        cmp   r0, #0
        bgt   _sil_dly_nse1
        bx    lr

