/*
 *  rommon Simple Monitor
 * 
 *  Copyright (C) 1999-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2006-2015 by GJ Business Division
 *                   RICOH COMPANY,LTD. JAPAN
 *  Copyright (C) 2016-2018 by TOPPERS PROJECT Educational Working Group.
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */

#ifndef _MONDEFS_H_
#define _MONDEFS_H_

/*
 *	mondefs.h -- rom Monitor Core Definitions
 */

/*	Prompt		*/

#define MONITOR_PROMPT		':'

/*	Command		*/

#define MONCMD_ENTER_LONG   (('e' << 8) | 'l')
#define MONCMD_ENTER_WORD   (('e' << 8) | 'w')
#define MONCMD_ENTER_BYTE   (('e' << 8) | 'b')
#define MONCMD_DUMP_LONG    (('d' << 8) | 'l')
#define MONCMD_DUMP_WORD    (('d' << 8) | 'w')
#define MONCMD_DUMP_BYTE    (('d' << 8) | 'b')
#define MONCMD_FILL_BYTE    (('f' << 8) | 'b')
#define MONCMD_LOAD         (('l' << 8) | 'd')
#define MONCMD_GO           (('g' << 8) | 'o')
#define MONCMD_FL           (('f' << 8) | 'l')
#define MONCMD_LS           (('l' << 8) | 's')

/*	Error Code	*/

#define ERR_CHECK_SUM		0xf1

#ifndef _MACRO_ONLY
/*
 *	External Data
 */
extern const unsigned short CommandString[];
#ifndef NOT_DEFVECTORTYPE
extern unsigned long MonitorVector[];
extern unsigned long UserVector[];
#endif

extern char  *AddressPointer[];
extern char  *DumpPointer[];
extern unsigned char CommandMode[];
extern unsigned char Status[];

/*
 *	External Functions
 */
extern void SendPrompt(int id);
extern void BeforeInit(void);
extern void AfterInit(void);
extern int  VolumeInit(void);

extern void EnterByteCmd(int id, char **ps);
extern void EnterWordCmd(int id, char **ps);
extern void EnterLongCmd(int id, char **ps);
extern void DumpByteCmd(int id, char **ps);
extern void DumpWordCmd(int id, char **ps);
extern void DumpLongCmd(int id, char **ps);
extern void FillByteCmd(int id, char **ps);
extern void ParseCmdCore(int id);
extern void MonSendPrompt(int id);

extern unsigned long load_file(int id, unsigned long addr, unsigned long dsize, char *path);
extern void disp_dir(int id, char *path);

#endif	/* _MACRO_ONLY */
#endif	/* of #ifndef _MONDEFS_H_ */
