/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003-2009 by Ryosuke Takeuchi
 *                     GJ Business Division RICOH COMPANY,LTD. JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  (1)(4)ξ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: stddev.c,v 1.2 2009/03/11 23:53:29 roi Exp $
 */

/*
 *  ROM˥CPU¸ץࡥ
 *
 */

#include <sys_defs.h>
#include <stdio.h>
#include <string.h>
#include "serial.h"


/******************************************************************************
 * ̾ɸϤ
 ******************************************************************************/

FILE _iob[4];
static int stdport;

/*
 *  ˥Σʸʸ
 */
static int
local_getc(void *dev)
{
	int c;

	while((c = ReciveChar(*((int *)dev))) == 0){
	}
	return c;
}

/*
 *  ˥Σʸʸ
 */
static int
local_gets(void *dev, unsigned int len, char *s)
{
	int i;

	for(i = 0 ; i < len ; i++)
		s[i] = local_getc(dev);
	return len;
}

/*
 *  ˥Σʸʸ
 */
static void
local_putc(void *dev, int c)
{
	SendChar(*((int *)dev), c);
}

/*
 *  ˥ʸʸ
 */
static int
local_puts(void *dev, unsigned int len, char *s)
{
	int i;

	for(i = 0 ; i < len ; i++)
		SendChar(*((int *)dev), s[i]);
	return len;
}

/*
 *  ˥Υǡեåʸ
 */
static int
local_flush(FILE *st)
{
	return 0;
}

/*
 *  ɸϴؿ
 */
int fputc(int c, FILE *st)
{
	if(st == NULL)
		st = stdout;
	if(c == '\n')
		st->_func_out(st->_dev, '\r');
	st->_func_out(st->_dev, c);
	return 1;
}

/*
 *  ɸϴؿ
 */
int fgetc(FILE *st)
{
	if(st == NULL)
		st = stdin;
	return st->_func_in(st->_dev);
}

/*
 *  ɸʸϴؿ
 */
int fgets(char *buf, int size, FILE *st)
{
	if(st == NULL)
		st = stdin;
	return st->_func_ins(st->_dev, size, buf);
}

/*
 *  ɸǡɤ߽Фؿ
 */
size_t fread(void *buf, size_t size, size_t count, FILE *st)
{
	if(st == NULL)
		st = stdin;
	return st->_func_ins(st->_dev, size*count, buf);
}

/*
 *  ɸǡ񤭹ߴؿ
 */
size_t fwrite(const void *buf, size_t size, size_t count, FILE *st)
{
	if(st == NULL)
		st = stdout;
	return st->_func_outs(st->_dev, size*count, (char *)buf);
}

/*
 *  ɸʸϴؿ
 */
int puts(const char *s)
{
	int status;

	status = stdout->_func_outs(stdout->_dev, strlen(s), (char *)s);
	stdout->_func_out(stdout->_dev, '\r');
	stdout->_func_out(stdout->_dev, '\n');
	return status;
}

/*
 *  ʸϥץ
 */
int putchar(int c)
{
	return fputc(c,stdout);
}

/*
 *  ХåեΥեåؿ
 */
int fflush(FILE *st)
{
	if(st == NULL)
		st = stdout;
	return st->_func_flush(st);
}

/*
 *  ɸϽؿ
 */
void _setup_stdio(int port)
{
	int i;

	if(port >= 0 && port < MAX_SERIAL){
		stdport = port;
		for(i = 0 ; i < 3 ; i++){
			_iob[i]._file       = -1;
			_iob[i]._func_in    = local_getc;
			_iob[i]._func_ins   = local_gets;
			_iob[i]._func_out   = local_putc;
			_iob[i]._func_outs  = local_puts;
			_iob[i]._func_flush = local_flush;
			_iob[i]._dev        = (void *)&stdport;
		}
	}
}

/*
 *  ɸѥȥ꡼Фؿ
 */
FILE *_get_stdio(int no)
{
	return &_iob[no];
}

